#made by tak2hata  http://onigiriburning.so.land.to/
#made since 2009/10/25
#Exporter For mitsuba Render
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.

require 't2h_su2objmtl_mitsuba/mod_su2objmtl.rb'
require 't2h_su2objmtl_mitsuba/mod_mitsuba_material.rb'
require 't2h_su2objmtl_mitsuba/mod_mitsuba_settings.rb'
require 't2h_su2objmtl_mitsuba/mod_mitsuba_light.rb'
module TAK2HATA
module SU2MITSUBA
class SU2MITSUBA
	include SU2OBJMTL
	include MATERIAL_EDIT
	include SETTINGS
	include LIGHTINGS
	def startexport(render_props )
		save_render_path_ini()
		all_init
		folder_setup()
		export(render_props)
	end

	def export_geom_text()
	#mtsimportの使い方
	#mtsimport -a su_render\tx_default su_render\*.obj su_render\*.xml
	#これでマテリアル順にindexで指定できるserialized メッシュになる
		#export xml object
		
		gmf = File.new(@geomtext, "w")
		gmf.puts @storelightcode
		i = 0
		vsc =  1.inch.to_m.to_f
		sctr = Geom::Transformation.scaling( [0,0,0] , vsc,vsc,vsc )
		rottr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(1,0,0), -90.degrees )
		@instance_store.each{| cdf , ot , defmate , movec |
			tr = rottr * sctr * ot
			mtrx = tr.to_a
			#Sketchupの変形行列の並びが縦横違う
			#mtrx.map!{|v| ( v * 10000.0 ).round.to_f / 10000.0 }
			mtrx2 =  "#{mtrx[0]} #{mtrx[4]} #{mtrx[8]} #{ mtrx[12]} "
			mtrx2 << "#{mtrx[1]} #{mtrx[5]} #{mtrx[9]} #{ mtrx[13]} "
			mtrx2 << "#{mtrx[2]} #{mtrx[6]} #{mtrx[10]} #{mtrx[14]} "
			mtrx2 << "#{mtrx[3]} #{mtrx[7]} #{mtrx[11]} #{mtrx[15]} "
			
			j = @mesh_start_index[cdf]
			@matnamelist[cdf].each{|matname|
				if matname == ""
					if defmate == ""
						matname = "t2h_su2objmtl_default_material"
					else
						matname = defmate
					end
				end
				matcode = @matcodelist[matname]
				if cdf.is_a?(Sketchup::ComponentInstance)
					objname = enc_kconv( cdf.name )
				elsif cdf.is_a?(Sketchup::Group)
					objname = "GROUP_" + cdf.entityID.to_s
				else
					objname = "MAIN"
				end
				if not matcode
					matname = "t2h_su2objmtl_default_material"
					matid = "MATERIAL_#{matname}"
					objname = objname + matname + "su2objmtl" + i.to_s
					gmf.puts '<shape id="' + objname + '" type="serialized"><string name="filename" value="' + @export_dir.gsub(/\\/,"/") + '/mitsuba_main.serialized"/><integer name="shapeIndex" value="' + j.to_s + '"/>'
					gmf.puts '<ref name="bsdf" id="' + matid + '"/>'
				else
					objname = objname + matname + "su2objmtl" + i.to_s
					matid = "MATERIAL_#{matname}"
					gmf.puts '<shape id="' + objname + '" type="serialized"><string name="filename" value="' + @export_dir.gsub(/\\/,"/") + '/mitsuba_main.serialized"/><integer name="shapeIndex" value="' + j.to_s + '"/>'
					gmf.puts '<ref name="bsdf" id="' + matid + '"/>'
					gmf.puts '<!--' + matname + '-->'
				end
				if movec and movec.length > 0
					gmf.puts %Q{<animation name="toWorld">
<transform time="0"><matrix value="#{mtrx2}"/></transform>
<transform time="1"><matrix value="#{mtrx2}"/><translate x="#{movec.x.to_m.to_f}" y="#{movec.z.to_m.to_f}" z="#{-movec.y.to_m.to_f}"/></transform>
</animation>}
				else
					gmf.puts '<transform name="toWorld"><matrix value="' + mtrx2 + '"/></transform>'
				end
					gmf.puts '</shape>'
				j += 1
				i += 1
			}
		}
		
		gmf.flush
		gmf.close
		return
		
	end

	def export(render_props)
		scprops = render_props["scene"]
		pages = Sketchup.active_model.pages
		@objmode = scprops["Setting"]["ExportMode"][0]
		@viewmode = scprops["Setting"]["ExportView"][0]
		#次のケースはページが足りないときはエラーするので前もって、止める。
		return if @viewmode == "All_scenes" and pages.count == 0
		return if @viewmode == "Animation" and pages.count < 2
		
		buffer_init if @objmode == "Refresh_Models"
		
		@starttime = Time.now.to_f
		#@title = "Mitsuba"

		@geomtext = "mitsuba_geom.txt"
		@geomtext = File.join(@export_dir,(@geomtext))

		Sketchup.set_status_text "export OBJ_file"
		@storelightcode = ""
		@geomfilename = "Mitsuba_geometries.xml"
		@geomfilename_tr = "Mitsuba_geometries_tr.xml"
		@geomfile =  File.join(@export_dir,(@geomfilename))
		@geomfile_tr =  File.join(@export_dir,(@geomfilename_tr))
		
		Sketchup.set_status_text "create GeometriesGroup_file"
		#Sketchup.active_model.start_operation("explode images")
		expchk = explode_images()
		@s2v_used_material = []
		Sketchup.active_model.materials.each{|mat| @s2v_used_material.push mat }
		export_textures
		export_geom_xml()
		Sketchup.active_model.commit_operation
		Sketchup.undo if expchk == true#when image object were exploded.
		@instance_store = nil
		
		wastetime = Time.now.to_f - @starttime
		Sketchup.set_status_text "OBJ&MTL export finished! time is #{wastetime} sec"
		p "OBJ&MTL export finished! time is #{wastetime} sec"
		Sketchup.set_status_text "creat Scene_file"
		render_path = @render_path.gsub(/\//,"\\")
		settingfile = scprops["Setting"]["ReadScene"][0]||""
		fwidth = scprops["Setting"]["ImageWidth"][0]||"800"
		fheight = scprops["Setting"]["ImageHeight"][0]||"600"
		@render_setting_code = {}
		if settingfile and settingfile != ""
			@render_setting_code = get_rendersetting_from_scene(settingfile,fwidth,fheight)
		end
		fformat = scprops["Setting"]["ImageFormat"][0]||"EXR"
		fformat = "EXR" if fformat == "MULTI"
		if @viewmode == "All_Scenes"
			pgcount = 0
			delete_scene_xmlfile()
			pages.each{|page|
				pages.selected_page = page
				scenefilename = %Q{Mitsuba_scene_#{"%05d" % pgcount}.xml}
				Sketchup.set_status_text "creat Scene_file:#{scenefilename}"
				@scenefile =  File.join(@export_dir,(scenefilename))
				export_render_scene(render_props,@scenefile)
				pgcount += 1
			}
			create_batch_render(render_path,pgcount,fformat)
		elsif @viewmode == "Animation"
			fps = scprops["Setting"]["FPS"][0]||30
			maxframe = ( pages.slideshow_time * fps.to_i ).to_i
			delete_scene_xmlfile()
			(0..maxframe).each{|framecount|
				pages.show_frame_at ( framecount.to_f / fps.to_f )
				scenefilename = %Q{Mitsuba_scene_#{"%05d" % framecount}.xml}
				Sketchup.set_status_text "creat Scene_file:#{scenefilename}"
				@scenefile =  File.join(@export_dir,(scenefilename))
				export_render_scene(render_props,@scenefile)
			}
			create_batch_render(render_path,maxframe,fformat)
		else# @viewmode == "This_View"
			scenefilename = "Mitsuba_scene.xml"
			@scenefile =  File.join(@export_dir,(scenefilename))
			export_render_scene(render_props,@scenefile)
			if scprops["Setting"]["UI"][0] == "GUI"
				if RUBY_PLATFORM[/darwin/]
					render_path_gui = File.join(@render_path,"Contents","MacOS","mtsgui")
					commandline = %Q{open -a "#{render_path.gsub(/\\/,'/')}" "#{@scenefile.gsub(/\\/,'/')}"/}
				else
					render_path_gui = File.join( File.dirname( render_path ) , "mtsgui.exe" )
					commandline = %Q{start "max" "#{render_path_gui}" "#{@scenefile.gsub(/\//,"\\")}"}
					##commandline = %Q{start "max" "#{render_path}" "#{@scenefile.gsub(/\//,"\\")}" "-r 12" }
				end
				system(commandline)
			else
				if RUBY_PLATFORM[/darwin/]
					render_path_cui = File.join(@render_path,"Contents","MacOS","mitsuba")
					commandline = %Q{open -a "#{render_path_cui.gsub(/\\/,'/')}" "#{@scenefile.gsub(/\\/,'/')}"/}
					system(commandline)
				else
					render_path_cui = File.join( File.dirname( render_path ) , "mitsuba.exe" )
					create_batch_render_1scene(render_path,fformat)
					##commandline = %Q{start "max" "#{render_path}" "#{@scenefile.gsub(/\//,"\\")}" "-r 12" }
				end
			end
		end
	end
	def create_batch_render_field(fformat="PNG",scenename="Mitsuba_scene")
		render_dir = File.dirname( @render_path )
		scenepath = File.join( render_dir , "su_render" , "#{scenename}.xml" )
		outputfile = File.join( render_dir , "su_render" , "#{scenename}.#{fformat.downcase}" )
		if RUBY_PLATFORM[/darwin/]
			render_path2 = File.join(@render_path,"Contents","MacOS","mitsuba")
			commandline = %Q{#{render_path2} -q -o '#{outputfile.gsub(/\\/,'/')}' '#{scenepath.gsub(/\\/,'/')}'}
		else
			render_path2 = File.join( render_dir , "mitsuba.exe" )
			commandline = "\"#{render_path2.gsub(/\//,"\\")}\" -o \"#{outputfile.gsub(/\//,"\\")}\" \"#{scenepath.gsub(/\//,"\\")}\" "
		end
		p commandline
		system(commandline)
	end
	def create_batch_render_1scene(render_path,fformat,scenename="Mitsuba_scene")
		#render_path2 = File.join( File.dirname( render_path ) , "mitsuba.exe" )
		batchpath = File.join( File.dirname( render_path ) , "render_batch.bat" )
		f = open(batchpath,"w+")
		f.puts 'C:'
		f.puts 'cd ' + File.dirname( render_path )
		f.puts %Q{"mitsuba.exe" "su_render\\#{scenename}.xml" -o "su_render\\output\\#{scenename}.#{fformat.downcase}"}
		f.puts %Q{"mtsgui.exe" "su_render\\output\\#{scenename}.#{fformat.downcase}"}
		f.puts %Q{exit}
		f.close
		commandline = %Q{start "max" "#{batchpath}"}
		system(commandline)
	end
	def create_batch_render(render_path,counter,fformat)
		render_path2 = File.join( File.dirname( render_path ) , "mitsuba.exe" )
		batchpath = File.join( File.dirname( render_path ) , "render_batch.bat" )
		

		f = open(batchpath,"w+")
		f.puts 'C:'
		f.puts 'cd ' + File.dirname( render_path )
		(counter).times{|t|
			f.puts %Q{"mitsuba.exe" "su_render\\Mitsuba_scene_#{"%05d" % t}.xml" -q -o "su_render\\output\\Mitsuba_scene_#{"%05d" % t}.#{fformat.downcase}"}
		}
		f.close
		res = UI.messagebox("Start Animation rendering?",MB_OKCANCEL)
		if res == 1 #OK
			commandline = %Q{start "max" "#{batchpath}"}
			system(commandline)
		end
	end

	def get_rendersetting_from_scene(settingfile,fwidth,fheight)
		#アニメーション用のレンダリング設定を保存されたシーンから取り込む
		buff_hash = {}
		if File.exists?( settingfile )
			scf = File.new(settingfile, "r")
			scfbuff = scf.read
			scf.close
			
			if /(<integrator.*\/integrator>)/m =~ scfbuff
				buff_hash["integrator"] = $1
			end
			
			if /(<sampler.*\/sampler>)/m =~ scfbuff
				buff_hash["sampler"] = $1
			end
			
			if /(<film.*\/film>)/m =~ scfbuff
				abuff = $1
				abuff.gsub!(/<integer name="width" value="\d+"\/>/,%Q{<integer name="width" value="#{fwidth}"/>})
				abuff.gsub!(/<integer name="height" value="\d+"\/>/,%Q{<integer name="height" value="#{fheight}"/>})
				abuff.gsub!(/(<integer name="crop.*".*\/>)/,"")
				buff_hash["film"] = abuff
			end
		end
		return buff_hash
	end
	def delete_scene_xmlfile()
		if @export_dir and @export_dir != "" and File.exists?( @export_dir )
			Dir::glob(File.join(@export_dir,("Mitsuba_scene_*.xml"))).each {|f|
				File.delete( f )
			}
		end
	end
	def export_collada_file()
		if RUBY_PLATFORM[/darwin/]
			cnvt_path = File.join(@render_path , "Contents","MacOS" , "mtsimport")
		else
			cnvt_path = File.join(File.dirname(@render_path) , "mtsimport.exe")
		end
		objfile = File.join(@export_dir,"mitsuba_main.dae")
		xmlfile = File.join(@export_dir,"mitsuba_main.xml")

		@obuff = ""
		@obuff << '<?xml version="1.0" encoding="UTF-8" standalone="no" ?>'
		@obuff << '<COLLADA xmlns="http://www.collada.org/2005/11/COLLADASchema" version="1.4.1">'
		@obuff << '<asset><contributor><authoring_tool>T2H_SU2OBJMTL_MITSUBA</authoring_tool></contributor>'
		@obuff << '<unit meter="0.0254" name="inch" /><up_axis>Z_UP</up_axis></asset>'

		Sketchup.set_status_text "exportt OBJ_file"
		@obuff << '<library_geometries>'
		export_obj()

		@obuff << '</library_geometries>'
		
		@obuff << '<library_visual_scenes><visual_scene id="ID1"><node name="SketchUp">'
		@dae_objlist.each{|objID|
			@obuff << '<instance_geometry url="#' + objID + '"></instance_geometry>'
		}
		@obuff << '</node></visual_scene></library_visual_scenes>'
		@obuff << '<scene><instance_visual_scene url="#ID1" /></scene></COLLADA>'
		
		of = File.new(objfile, "w")
		of.puts @obuff
		of.close
		@obuff = nil

		wastetime = Time.now.to_f - @starttime
		Sketchup.set_status_text "OBJ exported:#{wastetime} sec"
		p "OBJ file exported:#{wastetime} sec"
		if RUBY_PLATFORM[/darwin/]
			#commandline = %Q{#{cnvt_path} #{objfile.gsub(/\\/,'/')} #{xmlfile.gsub(/\\/,'/')}}
			#20140320 modified by the information from driven.thanks! 
			commandline = %Q{cd /Applications && Mitsuba.app/Contents/MacOS/mtsimport #{objfile.gsub(/\\/,'/')} #{xmlfile.gsub(/\\/,'/')}}
		else
			commandline = %Q{"#{cnvt_path}" "#{objfile}" "#{xmlfile}"  }
		end
		
		system(commandline)

		#File.delete(xmlfile)
	end

	def export_geom_xml()
		geombuff =  %Q{<?xml version="1.0" encoding="utf-8"?><!--	T2H SU2oOBJMTL_MITSUBA converted from Collada --><scene version="0.5.0">\n}
		txcode_buff = export_mtl_material()
		geombuff << txcode_buff
		
		@matcodelist.each{|matname,matcode_ar|
			matcode1 = matcode_ar[0]
			matcode2 = matcode_ar[1]
			trans = matcode_ar[2]
			geombuff << matcode1
		}
		if @objmode == "Refresh_Models" or @geom_cashed == nil or @geom_cashed != Sketchup.active_model.path or File.exists?( @geomtext ) == false
			export_collada_file()
			export_geom_text()
			@geom_cashed = Sketchup.active_model.path
		elsif Sketchup.active_model.definitions.find{|cdf| cdf.name == "T2H_PointLight" or cdf.name == "T2H_SPOTLIGHT" }
			@t2h_stored_lights = []
			start_store_lights()
		end
		geombuff_tr = "" + geombuff
		gmf = File.new(@geomtext, "r")
		shapebuff = ""
		chk_shape = false
		trans = false
		gmf.each{|line_gmf|
			if line_gmf.include?('</shape>')
				shapebuff << line_gmf
				geombuff << shapebuff
				if trans == false
					geombuff_tr << shapebuff
				end
				chk_shape = false
				shapebuff = ""
			elsif chk_shape == true
				@matcodelist.each{|matname,matcode_ar|
					matcode1 = matcode_ar[0]
					matcode2 = matcode_ar[1]
					trans2 = matcode_ar[2]
					cmtline = '<!--' + matname + '-->'
					if line_gmf.index(cmtline)
						trans = trans2
						shapebuff << matcode2 + "\n"
						break
					end
				}
				shapebuff << line_gmf
			elsif line_gmf.include?('<shape id=')
				trans = false
				chk_shape = true
				shapebuff = line_gmf
			end
		}
		gmf.close
		geombuff << "</scene>"
		geombuff_tr << "</scene>"
		of = File.new(@geomfile, "w")
		of.puts geombuff
		of.flush
		of.close
		of = File.new(@geomfile_tr, "w")
		of.puts geombuff_tr
		of.flush
		of.close
	end
	def export_render_scene(render_props,scenefile)# ,usesun = true,ibl = "" )
		scprops = render_props["scene"]
		intprops = render_props["integrator"]
		adptprops = render_props["adaptive"]
		irrprops = render_props["irrcache"]
		smplprops = render_props["sampler"]
		ldrprops = render_props["ldr"]

		camera = Sketchup.active_model.active_view.camera
		Sketchup.set_status_text "create scene_file"
		eye = camera.eye
		tar = camera.target
		cup = camera.up
		mtbscale = (1.0).to_f
		prec6 = 1000000.0
		vtscale = 1.inch.to_m.to_f * prec6
		pos = "#{( eye.x * vtscale ).round / prec6 },#{( eye.z * vtscale ).round / prec6  },#{( -eye.y * vtscale ).round / prec6 }"
		lookat = "#{(tar.x * vtscale ).round / prec6  },#{(tar.z * vtscale ).round / prec6  },#{(-tar.y * vtscale ).round / prec6 }"
		upvec = "#{( cup.x * prec6 ).round / prec6 },#{(cup.z  * prec6 ).round / prec6 },#{( -cup.y * prec6 ).round / prec6 }"
		fheight = scprops["Setting"]["ImageHeight"][0]||600.to_s
		fwidth = scprops["Setting"]["ImageWidth"][0]||800.to_s
		fformat = scprops["Setting"]["ImageFormat"][0]||"EXR"
		fannot = scprops["Setting"]["Annotation"][0]||"Logo+Statics"
		ffilter = scprops["RenderOption"]["rfilter"][0]||"mitchell"
		sampler = scprops["RenderOption"]["sampler"][0]||"independent"
		fdist = scprops["RenderOption"]["focusDistance"][0]||"#{(camera.focal_length.to_m.to_f * prec6).round / prec6 }"
		aprad = scprops["RenderOption"]["apertureRadius"][0]||"0.0"
		finte = scprops["RenderOption"]["integrator"][0]||"volpath"
		fadapt = scprops["RenderOption"]["adaptive"][0]||"off"
		firr = scprops["RenderOption"]["irrcache"][0]||"off"
		flens = scprops["RenderOption"]["type"][0]||"perspective"
		fratio = "#{(@fr.to_f * prec6).round / prec6 }"
		fov = "#{(camera.fov * prec6).round / prec6 }" 
		sv_albedo = scprops["Setting"]["SaveAlbedo"][0]||"No"
		sv_dist = scprops["Setting"]["SaveDistance"][0]||"No"
		scenecode_ar = []
		fieldcode = {}
		fieldcode["albedo"] = []
		fieldcode["distance"] = []
		headercode = %Q{<?xml version="1.0" encoding="utf-8"?><!--	T2H SU2oOBJMTL_MITSUBA converted from Collada --><scene version="0.5.0">}
		scenecode_ar.push headercode
		fieldcode["albedo"].push headercode
		fieldcode["distance"].push headercode
		scenecode_ar.push %Q{<include filename="#{@geomfilename}"/>}
		fieldcode["albedo"].push %Q{<include filename="#{@geomfilename_tr}"/>}
		fieldcode["distance"].push %Q{<include filename="#{@geomfilename_tr}"/>}

		multichannel = false
		multichannel = true if fformat == "MULTI"
		if @render_setting_code["integrator"]
			scenecode_ar.push @render_setting_code["integrator"]
		else
			if ["direct","path","volpath","volpath_simple","photonmapper"].index(finte) and sampler == "independent"
				if fadapt == "on"
					scenecode_ar.push %Q{<integrator type="adaptive">}
					adptprops.each{|key,arr|
						scenecode_ar.push %Q{<#{arr[1]} name="#{key}" value="#{arr[0]}"/>}
					}
				end
				if firr == "on"
					scenecode_ar.push %Q{<integrator type="irrcache">}
					irrprops.each{|key,arr|
						scenecode_ar.push %Q{<#{arr[1]} name="#{key}" value="#{arr[0]}"/>}
					}
				end
			end
			if ["albedo","distance"].index(finte)
				scenecode_ar.push %Q{<integrator type="field"><string name="field" value="#{finte}"/></integrator>}
			else
				scenecode_ar.push %Q{<integrator type="#{finte}">}
				intprops.each{|key,arr|
					scenecode_ar.push %Q{<#{arr[1]} name="#{key}" value="#{arr[0]}"/>}
				}
				scenecode_ar.push %Q{</integrator>}
			end
			if ["direct","path","volpath","volpath_simple","photonmapper"].index(finte) and sampler == "independent"
				if firr == "on"
					scenecode_ar.push %Q{</integrator>}
				end
				if fadapt == "on"
					scenecode_ar.push %Q{</integrator>}
				end
			end
		end
		fieldcode["albedo"].push %Q{<integrator type="field"><string name="field" value="albedo"/></integrator>}
		fieldcode["distance"].push %Q{<integrator type="field"><string name="field" value="distance"/></integrator>}
		tempcode_ar = []
		tempcode_ar.push %Q{<sensor type="#{flens}">}
		if flens == "thinlens"
			tempcode_ar.push %Q{<float name="focusDistance" value="#{fdist}"/>}
			tempcode_ar.push %Q{<float name="apertureRadius" value="#{aprad}"/>}
			tempcode_ar.push %Q{<float name="fov" value="#{fov}"/>}
			tempcode_ar.push %Q{<string name="fovAxis" value="smaller"/>}
		elsif flens == "perspective"
			tempcode_ar.push %Q{<float name="fov" value="#{fov}"/>}
			tempcode_ar.push %Q{<string name="fovAxis" value="smaller"/>}
		elsif flens == "telecentric"
			tempcode_ar.push %Q{<float name="apertureRadius" value="#{aprad}"/>}
			tempcode_ar.push %Q{<float name="fov" value="#{fov}"/>}
		elsif flens == "orthographic" or flens == "spherical" or flens == "radiancemeter" or flens == "fluencemeter"
		end
		tempcode_ar.push %Q{<float name="shutterOpen" value="0"/>}
		tempcode_ar.push %Q{<float name="shutterClose" value="1"/>}
		tempcode_ar.push %Q{<transform name="toWorld">}
		tempcode_ar.push %Q{		<lookat origin="#{pos}" target="#{lookat}" up="#{upvec}"/>}
		tempcode_ar.push %Q{</transform>}
		fieldcode["albedo"].concat tempcode_ar
		fieldcode["distance"].concat tempcode_ar

		if @render_setting_code["sampler"]
			tempcode_ar.push @render_setting_code["sampler"]
		else
			tempcode_ar.push %Q{<sampler type="#{sampler}">}
			smplprops.each{|key,arr|
				tempcode_ar.push %Q{<#{arr[1]} name="#{key}" value="#{arr[0]}"/>}
			}
			tempcode_ar.push %Q{</sampler>}
		end
		scenecode_ar.concat tempcode_ar
		fieldcode["albedo"].push %Q{<sampler type="independent"/>}
		fieldcode["albedo"].push %Q{<film type="ldrfilm"><string name="pixelFormat" value="rgba"/><integer name="height" value="#{fheight}"/><integer name="width" value="#{fwidth}"/><rfilter type="#{ffilter}"/></film></sensor>}
		fieldcode["distance"].push %Q{<sampler type="independent"/>}
		fieldcode["distance"].push %Q{<film type="ldrfilm"><string name="pixelFormat" value="rgba"/><float name="exposure" value="-10"/><integer name="height" value="#{fheight}"/><integer name="width" value="#{fwidth}"/><rfilter type="#{ffilter}"/></film></sensor>}

		if @render_setting_code["film"]
			scenecode_ar.push @render_setting_code["film"]
		else
			if fformat == "EXR"
				scenecode_ar.push %Q{<film type="hdrfilm">}
					scenecode_ar.push %Q{		<string name="pixelFormat" value="rgba"/>}
			elsif multichannel == true
					scenecode_ar.push %Q{<film type="hdrfilm">}
					scenecode_ar.push %Q{		<string name="pixelFormat" value="rgba, rgb"/>}
					scenecode_ar.push %Q{		<string name="channelNames" value="color, albedo"/>}
			else
				scenecode_ar.push %Q{<film type="ldrfilm">}
				scenecode_ar.push %Q{		<string name="pixelFormat" value="rgba"/>}
				scenecode_ar.push %Q{<string name="tonemapMethod" value="gamma"/>}
				ldrprops.each{|key,arr|	scenecode_ar.push %Q{<#{arr[1]} name="#{key}" value="#{arr[0]}"/>}	}
			end
			scenecode_ar.push %Q{		<integer name="height" value="#{fheight}"/>}
			scenecode_ar.push %Q{		<integer name="width" value="#{fwidth}"/>}
			scenecode_ar.push %Q{		<rfilter type="#{ffilter}"/>}
			if fannot == "Logo+Statics"
				scenecode_ar.push %Q{		<boolean name="banner" value="true"/>}
				scenecode_ar.push %Q{		<string name="label[10, 10]" value="Integrator: $integrator['type'],$film['width']x$film['height'], $sampler['sampleCount'] spp,render time: $scene['renderTime'], memory: $scene['memUsage']"/>}
			elsif fannot == "Logo"
				scenecode_ar.push %Q{		<boolean name="banner" value="true"/>}
			elsif fannot == "Statics"
				scenecode_ar.push %Q{		<boolean name="banner" value="false"/>}
				scenecode_ar.push %Q{		<string name="label[10, 10]" value="Integrator: $integrator['type'],$film['width']x$film['height'], $sampler['sampleCount'] spp,render time: $scene['renderTime'], memory: $scene['memUsage']"/>}
			else
				scenecode_ar.push %Q{		<boolean name="banner" value="false"/>}
			end
			scenecode_ar.push %Q{</film>}
		end
		scenecode_ar.push %Q{</sensor>}

		#export Sun
		sinfo = Sketchup.active_model.shadow_info
		sd1 = sinfo["SunDirection"]
		s_ymdt = sinfo["ShadowTime"].getgm
		turbidity = 3#clear sky
		sweight =scprops["Sky"]["samplingWeight"][0]
		salbedo =scprops["Sky"]["albedo"][0]
		sscale = scprops["Sky"]["scale"][0]
		semitter = scprops["Sky"]["emitter"][0]
		sturbidity =scprops["Sky"]["turbidity"][0]
		ibl_file = scprops["Sky"]["envmap"][0]
		rotation = scprops["Sky"]["rotation"][0]
		suntr = Geom::Transformation.rotation( [0,0,0], Geom::Vector3d.new(0,0,1) , rotation.to_f.degrees )
		sd = sd1.transform( suntr )

		if semitter == "sun" or semitter == "sunsky"
			scenecode_ar.push %Q{<emitter type="#{semitter}">}
			scenecode_ar.push %Q{	<vector name="sunDirection" x="#{sd.x}" y="#{sd.z}" z="#{-sd.y}"/>}
			scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
			scenecode_ar.push %Q{	<float name="scale" value="#{sscale.to_s}"/>}
			scenecode_ar.push %Q{	<srgb name="albedo" value="##{salbedo.to_s}"/>}
			scenecode_ar.push %Q{	<float name="turbidity" value="#{sturbidity.to_s}"/>}
			scenecode_ar.push %Q{</emitter>}
		elsif semitter == "sky_directional"
			scenecode_ar.push %Q{<emitter type="sunsky">}
			scenecode_ar.push %Q{	<vector name="sunDirection" x="#{sd.x}" y="#{sd.z}" z="#{-sd.y}"/>}
			scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
			scenecode_ar.push %Q{	<float name="scale" value="#{sscale.to_s}"/>}
			scenecode_ar.push %Q{	<srgb name="albedo" value="##{salbedo.to_s}"/>}
			scenecode_ar.push %Q{	<float name="turbidity" value="#{sturbidity.to_s}"/>}
			scenecode_ar.push %Q{	<float name="sunRadiusScale" value="0.0"/>}
			scenecode_ar.push %Q{</emitter>}
		elsif semitter == "sky"
			scenecode_ar.push %Q{<emitter type="#{semitter}">}
			scenecode_ar.push %Q{	<vector name="sunDirection" x="#{sd.x}" y="#{sd.z}" z="#{-sd.y}"/>}
			scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
			scenecode_ar.push %Q{	<float name="scale" value="#{sscale.to_s}"/>}
			scenecode_ar.push %Q{	<srgb name="albedo" value="##{salbedo.to_s}"/>}
			scenecode_ar.push %Q{	<float name="turbidity" value="#{sturbidity.to_s}"/>}
			scenecode_ar.push %Q{</emitter>}
		elsif semitter == "directional"
			add_dirlightcode(scenecode_ar,sd)
		elsif semitter == "envmap" or semitter == "envmap_directional"
			if FileTest.exist? ( ibl_file )
				scenecode_ar.push %Q{<emitter type="envmap" id="ibl_emitter">}
				scenecode_ar.push %Q{	<string name="filename" value="#{ibl_file}"/>}
				scenecode_ar.push %Q{	<transform name="toWorld" ><rotate y="1" angle="#{rotation}"/></transform>}
				scenecode_ar.push %Q{	<float name="scale" value="3"/>}
				scenecode_ar.push %Q{</emitter>}
			elsif /^[A-F0-9][A-F0-9][A-F0-9][A-F0-9][A-F0-9][A-F0-9]$/i =~ ibl_file.to_s
				scenecode_ar.push %Q{<emitter type="constant">}
				scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
				scenecode_ar.push %Q{	<srgb name="radiance" value="##{ibl_file}"/>}
				scenecode_ar.push %Q{</emitter>}
			else
				scenecode_ar.push %Q{<emitter type="constant">}
				scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
				scenecode_ar.push %Q{	<srgb name="radiance" value="#FFFFFF"/>}
				scenecode_ar.push %Q{</emitter>}
			end
			if semitter == "envmap_directional"
				scenecode_ar.push %Q{<emitter type="sun">}
				scenecode_ar.push %Q{	<vector name="sunDirection" x="#{sd.x}" y="#{sd.z}" z="#{-sd.y}"/>}
				scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
				scenecode_ar.push %Q{	<float name="scale" value="#{sscale.to_s}"/>}
				scenecode_ar.push %Q{	<srgb name="albedo" value="##{salbedo.to_s}"/>}
				scenecode_ar.push %Q{	<float name="turbidity" value="#{sturbidity.to_s}"/>}
				scenecode_ar.push %Q{	<float name="sunRadiusScale" value="0.0"/>}
				scenecode_ar.push %Q{</emitter>}
				#add_dirlightcode(scenecode_ar,sd,"-1")
			end
		elsif semitter == "constant"
			scenecode_ar.push %Q{<emitter type="#{semitter}">}
			scenecode_ar.push %Q{	<float name="samplingWeight" value="#{sweight.to_s}"/>}
			scenecode_ar.push %Q{	<srgb name="radiance" value="#FFFFFF"/>}
			scenecode_ar.push %Q{</emitter>}
		end
		of = File.new(scenefile, "w")
		of.puts scenecode_ar.join("\n")
		@t2h_stored_lights.each{|lightprops|
			lightcode = []
			if lightprops["type"] == "pointlight"
				pos = lightprops["position"]
				irgb = srgb_to_rgb( lightprops["intensity_color"] )
				isc = lightprops["intensity_scale"].to_f
				irgb.map!{|i| i = i * isc }
				sw = lightprops["samplingWeight"]
				lightcode.push %Q{<emitter type="point">}
				lightcode.push %Q{	<point name="position" x="#{pos.x.to_m.to_f}" y="#{pos.z.to_m.to_f}" z="#{-pos.y.to_m.to_f}" />}
				lightcode.push %Q{	<float name="samplingWeight" value="#{sw}"/>}
				lightcode.push %Q{	<rgb name="intensity" value="#{irgb.join(",")}"/>}
				lightcode.push %Q{</emitter>}
			elsif lightprops["type"] == "spotlight"
				pos = lightprops["position"]
				tar = lightprops["target"]
				irgb = srgb_to_rgb( lightprops["intensity_color"] )
				isc = lightprops["intensity_scale"].to_f
				irgb.map!{|i| i = i * isc }
				sw = lightprops["samplingWeight"]
				cutangle = lightprops["cutoffAngle"]
				beamWidth = lightprops["beamWidth"]
				lightcode.push %Q{<emitter type="spot">}
				lightcode.push %Q{	<transform name="toWorld">}
				lightcode.push %Q{		<lookat origin="#{pos.x.to_m.to_f},#{pos.z.to_m.to_f},#{-pos.y.to_m.to_f}" target="#{tar.x.to_m.to_f},#{tar.z.to_m.to_f},#{-tar.y.to_m.to_f}"/>}
				lightcode.push %Q{	</transform>}
				lightcode.push %Q{	<float name="samplingWeight" value="#{sw}"/>}
				lightcode.push %Q{	<rgb name="intensity" value="#{irgb.join(",")}"/>}
				lightcode.push %Q{	<float name="cutoffAngle" value="#{cutangle}"/>}
				lightcode.push %Q{	<float name="beamWidth" value="#{beamWidth}"/>}
				lightcode.push %Q{</emitter>}
			end
			of.puts lightcode.join("\n")
		}
		
		of.puts "</scene>"
		of.flush
		of.close
		dirname = File.dirname(scenefile)
		basename = File.basename(scenefile,".*")
		render_path = @render_path.gsub(/\//,"\\")
		if sv_albedo == "Yes"
			scenefile2 = File.join( dirname , "#{basename}_Albedo.xml" )
			of = File.new(scenefile2, "w")
			of.puts fieldcode["albedo"].join("\n")
			of.puts "</scene>"
			of.flush
			of.close
			create_batch_render_field("PNG","#{basename}_Albedo")
		end
		if sv_dist == "Yes"
			scenefile2 = File.join( dirname , "#{basename}_Distance.xml" )
			of = File.new(scenefile2, "w")
			of.puts fieldcode["distance"].join("\n")
			of.puts "</scene>"
			of.flush
			of.close
			create_batch_render_field("PNG","#{basename}_Distance" )
		end
	end
	def add_dirlightcode(scenecode_ar,sd,irscale="-4")
		scenecode_ar.push %Q{<emitter type="directional">}
		scenecode_ar.push %Q{	<vector name="direction" x="#{-sd.x}" y="#{-sd.z}" z="#{sd.y}"/>}
		scenecode_ar.push %Q{	<float name="samplingWeight" value="10"/>}
		scenecode_ar.push %Q{	<blackbody name="irradiance" temperature="5200K" scale="1e#{irscale}"/>}
		scenecode_ar.push %Q{</emitter>}
	end
	#ここをサブクラスに継承して使う　obj_codeがない場合はオーバーライドしない。(通常のobjファイルを出力）
	def export_object_file( objname , matname, meshes,vts,uvs,nos, vcount = 1)
		return if meshes == nil

		if meshes.length != 0 and vts.length != 0
			if matname != ""
			else
				matname = "t2h_su2objmtl_default_material"
			end
			@objcount += 1
			objID = "#{objname}_#{@objcount}"
			@dae_objlist.push objID
			verticesID = "#{@objcount}_VerticesID_#{matname}"
			positionsID = "#{@objcount}_PosID_#{matname}"
			normalsID = "#{@objcount}_NorID_#{matname}"
			uvsID = "#{@objcount}_UVID_#{matname}"
			pos_vtlistID =  "#{@objcount}_#{positionsID}_VTLIST"
			nor_vtlistID =  "#{@objcount}_#{normalsID}_VTLIST"
			uvs_vtlistID =  "#{@objcount}_#{uvsID}_VTLIST"

			@obuff << %Q{
<geometry id="#{objID}"><mesh>
	<source id="#{positionsID}">
		<float_array id="#{pos_vtlistID}" count="#{vcount * 3}">#{vts}</float_array>
		<technique_common><accessor count="#{vcount}" source="##{pos_vtlistID}" stride="3"><param name="X" type="float" /><param name="Y" type="float" /><param name="Z" type="float" />		</accessor></technique_common>
	</source>
	<source id="#{normalsID}">
		<float_array id="#{nor_vtlistID}" count="#{vcount * 3}">#{nos}</float_array>
		<technique_common><accessor count="#{vcount}" source="##{nor_vtlistID}" stride="3"><param name="X" type="float" /><param name="Y" type="float" /><param name="Z" type="float" />		</accessor></technique_common>
	</source>
	<source id="#{uvsID}">
		<float_array id="#{uvs_vtlistID}" count="#{vcount * 2}">#{uvs}</float_array>
		<technique_common><accessor count="#{vcount}" source="##{uvs_vtlistID}" stride="2"><param name="S" type="float" /><param name="T" type="float" /></accessor></technique_common>
	</source>
	<vertices id="#{verticesID}"><input semantic="POSITION" source="##{positionsID}" /><input semantic="NORMAL" source="##{normalsID}" /></vertices>
	<triangles count="#{vcount}" material="#{matname}">
		<input offset="0" semantic="VERTEX" source="##{verticesID}" />
		<input offset="1" semantic="TEXCOORD" source="##{uvsID}" /><p>#{meshes.join}</p>
	</triangles>
</mesh></geometry>
}


		end

	end

end

unless file_loaded?("t2h_su2objmtl_mitsuba.rb")# File.basename(__FILE__)
	su2mtb = SU2MITSUBA.new
	main_menu = UI.menu("Plugins").add_submenu("T2H Mitsuba Render Exporter")
	main_menu.add_item("Export Settings") { su2mtb.render_show_webdialog }
	main_menu.add_item("Material Editor") { su2mtb.material_edit_show_webdialog }
	main_menu.add_item("Place PointLight") { su2mtb.start_place_light_tool( "pointlight" ) }
	main_menu.add_item("Place SpotLight") { su2mtb.start_place_light_tool( "spotlight" ) }
	main_menu.add_item("EDIT Light") { su2mtb.start_edit_light_tool}
	main_menu.add_item("Place Motion Vector") { su2mtb.place_force_vector }
	#main_menu.add_item("get sliders cede") { su2mtb.get_jq_sliders_code }
	add_toolbar = []
	toolbar = UI::Toolbar.new("T2H Mitsuba Render Exporter")
	add_toolbar.push [ "Export Settings" , UI::Command.new( "Export Settings" ) { su2mtb.render_show_webdialog } , "icon_mitsuba_edit.png" ]
	add_toolbar.push [ "Material Editor" , UI::Command.new( "Material Editor" ) { su2mtb.material_edit_show_webdialog } , "icon_mitsuba_material.png" ]
	add_toolbar.push [ "Place PointLight" , UI::Command.new( "Place PointLight" ) { su2mtb.start_place_light_tool( "pointlight" ) } , "icon_mitsuba_pointlight.png" ]
	add_toolbar.push [ "Place SpotLight" , UI::Command.new( "Place SpotLight" ) { su2mtb.start_place_light_tool( "spotlight" ) } , "icon_mitsuba_spotlight.png" ]
	add_toolbar.push [ "EDIT Light" , UI::Command.new( "EDIT Light" ) { su2mtb.start_edit_light_tool } , "icon_mitsuba_editlight.png" ]
	add_toolbar.push [ "Place Motion Vector" , UI::Command.new( "Place Motion Vector" ) { su2mtb.place_force_vector } , "icon_mitsuba_motion.png" ]
	pdir = File.dirname( File.expand_path(__FILE__) )
	add_toolbar.each{|cmdname , cmd , iconimage|
		cmd.large_icon = cmd.small_icon = File.join( pdir , iconimage )
		cmd.status_bar_text = cmd.tooltip = cmdname
		toolbar.add_item cmd
	}
	toolbar.show if toolbar.get_last_state != 0
end
file_loaded("t2h_su2objmtl_mitsuba.rb")
end
end
