module TAK2HATA
module SU2MITSUBA
module MAKEFUR
def furgen(r=100.mm)
	model = Sketchup.active_model
	ents = model.active_entities
	sels = model.selection
	t = Geom::Transformation.new
	starttime = Time.now
	ptslist = {}
	nor = Geom::Vector3d.new(0,0,0)
	sels.find_all{|e| e.is_a?(Sketchup::Face) }.each{|fc|
		msh = fc.mesh 5
		next if msh == nil
		msh.polygons.each{|polygon|
			polypts = polygon.map{|i| msh.point_at(i) }
			uvpts = polygon.map{|i| msh.uv_at(i , 1)}
			polygon.each{|i| 
				nor = nor + msh.normal_at(i)  / polygon.size
			}
			make_gridpoint(ptslist,r,polypts,uvpts,100.m)

		}
	}
	((ptslist.size/1000).to_i+1).times{|t|
		forcelist[ ptslist.keys[ t*1000 ] ] = { "direction"=>["left","right"][(rand*1.0).round] }
	}
	ptslist.each{|npt,uv|
		makebrades(npt,uv,nor,ftype,leng,stif,ljit,wjit,fjit,forcelist)
	}
	p "#{ptsslist.flatten.size}--#{Time.now - starttime}sec"
end
def makebrades(npt,uv,nor,ftype,leng,widt,stif,ljit,wjit,fjit,forcelist)
	fvec =Geom::Vector3d.new( 0,0,-1 )
	forcelist.each{|fpt,force|
		direction = force["direction"]
		dvec = fpt.vector_to(npt)
		dvec.length = fjit
		fvec = fvec + Geom::Vector3d.new( -dvec.y , dvec.x , 0.0 )
	}
	bradelength = leng + rand * ljit
	bradewidth =  widt + rand * wjit
	vec_l = nor
	vec_l.length = bradelength
	if fvec.samedirection?( vec_l ) or fvec.samedirection?( vec_l.reverse )
		vec_w = vec_l
		vec_w.length = bradewidth
		t = Geom::Transformation.rotation npt, vec_l, rand * 360.degrees
		vec_w.transform! t
	else
		vec_w = vec_l.cross( fvec )
		vec_w.length =bradewidth
	end
	(1..divs).each{|div|
		vts = []
		if div == 1
			if ftype == "Arch" #Linear|Arch|Leaf|Rectanguler
				dw = vector_scale( vec_w , Math.sqrt( 1 - div.to_f / divs.to_f ) )
			elsif ftype == "Leaf"
				fdy = ( 1.to_f - ( div.to_f + 1.to_f ) / divs.to_f * 2.to_f ).abs ** 0.5
				dw = vector_scale( vec_w , Math.sqrt( fdy ) )
			elsif ftype == langconv("Rectanguler") or ftype == "Rectanguler"
				dw = vec_w
			else
				dw = vector_scale( vec_w , ( 1.to_f - div.to_f / divs.to_f ) )
			end

			if ftype == "Leaf"
				pvts0 = npt
				pvts3 = point_add( npt , dvec_l2 )
				vts[0] = pvts0
				vts[1] = point_add( pvts3 , dw.reverse )
				vts[2] = point_add( pvts3 , dw )
				pvts1 =  point_add( pvts3 , dw )
				pvts2 = point_add( pvts3 , dw.reverse )
				pvts0 = pvts3
				dvec_l2 = vector_add( dvec_l2 , dforce )
				dvec_l2.length = dvec_l.length
				pvts3 = point_add( pvts3 , dvec_l2 )
			else
				pvts0 = npt
				pvts1 = point_add( npt , vec_w )
				pvts2 = point_add( npt , vec_w.reverse )
				pvts3 = point_add( npt , dvec_l2 )
				vts[0] = pvts1
				vts[1] = pvts2
				vts[2] = point_add( pvts3 , dw.reverse )
				vts[3] = point_add( pvts3 , dw )
				pvts1 = vts[3]
				pvts2 = vts[2]
				pvts0 = pvts3
				dvec_l2 = vector_add( dvec_l2 , dforce )
				dvec_l2.length = dvec_l.length
				pvts3 = point_add( pvts3 , dvec_l2 )
			end
		elsif div == divs
			if ftype == "Rectanguler"
				vts[0] = pvts1
				vts[1] = pvts2
				vts[2] = point_add( pvts3 , dw.reverse )
				vts[3] = point_add( pvts3 , dw )
			else
				vts[0] = pvts1
				vts[1] = pvts2
				vts[2] = pvts3
			end
		else
			if ftype == "Arch"
				dw = vector_scale( vec_w , Math.sqrt( 1.0 - div.to_f / divs.to_f ) )
			elsif ftype == "Leaf"
				fdy = ( 1.0 - div.to_f / divs.to_f * 2.0 ).abs ** 0.5
				dw = vector_scale( vec_w , Math.sqrt( 1.to_f - fdy ) )
			elsif ftype == "Rectanguler"
				dw = vec_w
			else
				dw = vector_scale( vec_w , ( 1.0 - div.to_f / divs.to_f ) )
			end
				vts[0] = pvts1
				vts[1] = pvts2
				vts[2] = point_add( pvts3 , dw.reverse )
				vts[3] = point_add( pvts3 , dw )
				pvts1 = vts[3]
				pvts2 = vts[2]
				pvts0 = pvts3
				dvec_l2 = vector_add( dvec_l2 , dforce )
				dvec_l2.length = dvec_l.length
				pvts3 = point_add( pvts3 , dvec_l2 )
		end
		pmesh.add_polygon vts
	}
end
def make_gridpoint(ptslist,r,polypts,uvpts,vradius=50.m)
	view = Sketchup.active_model.active_view
	eye = view.camera.eye
	cdir = view.camera.direction
	chk = false
	polypts.each{|pt|
		if valid_in_view( pt , eye , cdir , vradius ) != 0
			chk = true
			break
		end
	}

	return [] if chk == false
##初期化
	l=polypts[0].distance(polypts[1])+polypts[0].distance(polypts[2])
	indx=[0,1,2]
	if ( polypts[1].distance(polypts[0])+polypts[1].distance(polypts[2]) ) < l
		indx=[1,2,0]
		l= polypts[1].distance(polypts[0])+polypts[1].distance(polypts[2])
	end
	if ( polypts[2].distance(polypts[1])+polypts[2].distance(polypts[0]) ) < l
		indx=[2,0,1]
	end
	#indx[0]を頂点とする高さ
	pt0 = polypts[indx[0]]
	pt1 = polypts[indx[1]]
	pt2 = polypts[indx[2]]
	uv0 = uvpts[indx[0]]
	uv1 = uvpts[indx[1]]
	uv2 = uvpts[indx[2]]

	
	line12=[pt1,pt2]
	line01=[pt0,pt1]
	line02=[pt0,pt2]
	ll = pt1.distance(pt2).to_f
	h = pt0.distance_to_line(line12).to_f
	area = ll * h / 2.0
	#分割線上の端部離隔距離算定
	r = r.to_f
	adist = ll * r / pt2.distance_to_line( line01 ).to_f
	bdist = ll * r / pt1.distance_to_line( line02 ).to_f

##初期化終了
	#ptslist = [] #発生点のリスト
	#三角形の高さの分割数
	divh0 = ( h / r / ( 3 ** 0.5 ) ) #.to_i + 1
	#分布半径から離隔距離へ
	ldiv = r * 2.0

	if divh0 > 1.0
		divh = divh0.to_i + 2
		div2 = ( 2.0 * divh )
		divh.times{|n|
			n2 = 2.0 * n + 1.0
			pta  = Geom::Point3d.linear_combination( ( div2 - n2 ).to_f / div2  , pt0 , n2.to_f / div2 , pt1 )
			ptb  = Geom::Point3d.linear_combination( ( div2 - n2 ).to_f / div2  , pt0 , n2.to_f / div2 , pt2 )
			uva  = Geom::Point3d.linear_combination( ( div2 - n2 ).to_f / div2  , uv0 , n2.to_f / div2 , uv1 )
			uvb  = Geom::Point3d.linear_combination( ( div2 - n2 ).to_f / div2  , uv0 , n2.to_f / div2 , uv2 )

			l2 = pta.distance(ptb)
			div3 = ( ( l2 - adist - bdist ) / ldiv )
			if div3 >= 1.0
				div4 = div3.to_i + 1
				div4.times{|i|
					aw = ( ( l2 - adist - bdist ) * i.to_f / ( div4.to_f - 1.0 ) + adist ) / l2
					bw = 1.0- aw
					npt = Geom::Point3d.linear_combination( aw , pta , bw , ptb )
					nuv =  Geom::Point3d.linear_combination( aw , uva , bw , uvb )

					if valid_in_view(npt, eye , cdir , vradius ) != 0
						ptslist[ npt ] = nuv
					end
				}
			elsif div3 >= 0.0
				aw = ( ( l2 - adist - bdist ) / 2.0 + adist ) / l2
				bw = 1.0- aw
				npt = Geom::Point3d.linear_combination( aw , pta , bw , ptb )
				nuv =  Geom::Point3d.linear_combination( aw , uva , bw , uvb )

				if valid_in_view(npt, eye , cdir , vradius ) != 0
					ptslist[ npt ] = nuv
				end
			end
		}
	elsif divh0 > rand(0)
		#1本しか生えないので重心におく
		npt = [ ( pt0.x + pt1.x + pt2.x ) / 3.0 , ( pt0.y + pt1.y + pt2.y ) / 3.0 , ( pt0.z + pt1.z + pt2.z ) / 3.0 ]
		nuv = [ ( uv0.x + uv1.x + uv2.x ) / 3.0 , ( uv0.y + uv1.y + uv2.y ) / 3.0 , ( uv0.z + uv1.z + uv2.z ) / 3.0 ]

		if valid_in_view(npt,eye , cdir ,vradius) != 0
			ptslist[ npt ] = nuv
		end
	end

	#return ptslist
end
def valid_in_view(pt ,eye , cdir ,vradius=50.m)
	return 1
	if pt.distance(eye) > vradius
		#p "distance#{pt.distance(eye)}"
		return 0
	else ( 1.0 - pt.distance(eye) / vradius ) < 0.2
		#p "distance2#{ 1.0 - pt.distance(eye) / vradius}"
		return ( 1.0 - pt.distance(eye) / vradius )
	end
	odir = pt.vector_to(eye)
	ang = odir.angle_between( cdir )
	if ang.radians < 90
		#p "ang#{ang}"
		return 0
	end
	return 1
end

end#of module
end#module
end#module