module TAK2HATA
module SU2MITSUBA
module MATERIAL_WDLGCODING
	def create_matedit_htmlcode(cmat,coat_type="",bsdf_type="",light_type="",dipole_type="")
		dfprops , dfcoatprops ,	dflightprops , dfdipoleprops , dfotherprops = mitsuba_mat_properties_list()
		props ,coatprops,lightprops,dipoleprops = get_prop_from_material(cmat)

		if bsdf_type == ""
			if not props or not props["bsdf_type"]
				props["bsdf_type"] = "diffuse"
			end
		else
			props["bsdf_type"] = bsdf_type
		end
		if coat_type == ""
			if not coatprops or not coatprops["coat_type"]
				coatprops["coat_type"] = "none"
			end
		else
			coatprops["coat_type"] = coat_type
		end
		if light_type == ""
			if not lightprops or not lightprops["light_type"]
				lightprops["light_type"] = "none"
			end
		else
			lightprops["light_type"] = light_type
		end
		if dipole_type == ""
			if not dipoleprops or not dipoleprops["dipole_type"]
				dipoleprops["dipole_type"] = "none"
			end
		else
			dipoleprops["dipole_type"] = dipole_type
		end

		#p props.to_a
		bsdf = props["bsdf_type"]
		coat = coatprops["coat_type"]
		light = lightprops["light_type"]
		dipole = dipoleprops["dipole_type"]

		#filesplit = (__FILE__).split(File::Separator)
		basename = File.basename(__FILE__)
		dirname = File.dirname(__FILE__)

		htmfile = File.join( dirname, "su2objmtl_mitsuba_materialedit_copy.html" )
		f = open(htmfile)
		tbuff = f.read
		f.close
		tbuff.gsub!(/\[htmlpath\]/,dirname)
		addliststr = []
		bsdf = "diffuse" if not dfprops[bsdf]
		dfprops.keys.sort.each{|key|
		addliststr << key
		}
		dfcoatprops.keys.sort.each{|key|
			addliststr << key
		}
		dflightprops.keys.sort.each{|key|
			addliststr << key
		}
		dfdipoleprops.keys.sort.each{|key|
			addliststr << key
		}

		dfprops.each{|bsdfname,prophash|
			addliststr << "//BSDF TYPE:#{bsdfname}"
			prophash.keys.each{|dfkey|
				dftype = prophash[dfkey][0]
				prop = props[dfkey]||prophash[dfkey][1]
				dflist = prophash[dfkey][2]
				if dftype == "float" or dftype == "integer" or dftype == "blackbody"
					add_sliders_to_wdlg(addliststr,bsdfname,dfkey,prop,dflist,dftype)
				end
			}
		}

		dfcoatprops.each{|coatname,coatprophash|
			addliststr << "//COAT TYPE:#{coatname}"
			coatprophash.keys.each{|dfkey|
				dftype = coatprophash[dfkey][0]
				prop = coatprops[dfkey]||coatprophash[dfkey][1]
				dflist = coatprophash[dfkey][2]
				if dftype == "float" or dftype == "integer" or dftype == "blackbody"
					add_sliders_to_wdlg(addliststr,coatname,dfkey,prop,dflist,dftype)
				end
			}
		}

		dflightprops.each{|lightname,lighprophash|
			addliststr << "//LIGHT TYPE:#{lightname}"
			lighprophash.keys.each{|dfkey|
				dftype = lighprophash[dfkey][0]
				prop = lightprops[dfkey]||lighprophash[dfkey][1]
				dflist = lighprophash[dfkey][2]
				if dftype == "float" or dftype == "integer" or dftype == "blackbody"
					add_sliders_to_wdlg(addliststr,lightname,dfkey,prop,dflist,dftype)
				end
			}
		}

		dfdipoleprops.each{|dipolename,dipoleprophash|
			addliststr << "//DIPOLE TYPE:#{dipolename}"
			dipoleprophash.keys.each{|dfkey|
				dftype = dipoleprophash[dfkey][0]
				prop = dipoleprops[dfkey]||dipoleprophash[dfkey][1]
				dflist = dipoleprophash[dfkey][2]
				if dftype == "float" or dftype == "integer" or dftype == "blackbody"
					add_sliders_to_wdlg(addliststr,dipolename,dfkey,prop,dflist,dftype)
				end
			}
		}

		bump = ""
		bump = props["bump"]||""
		bumpscale = props["bumpscale"]||1
		bumpscale = 1 if bumpscale == ""
		addliststr << "//BUMP TYPE:"
		add_sliders_to_wdlg(addliststr,"other","bump_scale",bumpscale,"0|3","float")

		bumpwidth = props["bumpwidth"]||100
		bumpwidth = 100 if bumpwidth == ""
		add_sliders_to_wdlg(addliststr,"other","bump_width",bumpwidth,"100|2000|100","float")
		bumpheight = props["bumpheight"]||100
		bumpheight = 100 if bumpheight == ""
		add_sliders_to_wdlg(addliststr,"other","bump_height",bumpheight,"100|2000|100","float")

		jcmd = addliststr.join("\n")
		tbuff.gsub!(/\/\/slider_widget_code/,jcmd)
		
		mask = props["mask"]||"No"
		twosided = props["twosided"]||"Yes"

		addliststr = []

		dfprops.each{|bsdfname,prophash|
			addliststr.push %Q{<table class="mat_table" id="table_bsdf_#{bsdfname}">}
			addliststr.push '<tr><td colspan=2 bgcolor="#555555">' + bsdfname + 'Properties</td></tr>'
			prophash.keys.sort.each{|dfkey|
				prop = props[dfkey]||prophash[dfkey][1]
				dftype = prophash[dfkey][0]
				dflist = prophash[dfkey][2]
				add_props_to_wdlg(addliststr,props,bsdfname,dfkey,prop,dftype,dflist)
			}
			addliststr.push '</table>'
		}

		jcmd = addliststr.join("\n")
		tbuff.gsub!(/\[MAT_PROPS\]/,jcmd)
		
		addliststr = []
		addliststr.push %Q{<table class="mat_table" id="table_bump">}
		addliststr.push '<tr><td colspan=2 bgcolor="#555555">Other Properties</td></tr>'
		add_props_to_wdlg(addliststr,props,"bump","file",bump,"file","")
		add_props_to_wdlg(addliststr,props,"bump","scale",bumpscale,"float","0|3")
		add_props_to_wdlg(addliststr,props,"bump","width",bumpwidth,"float","100|2000|100")
		add_props_to_wdlg(addliststr,props,"bump","height",bumpheight,"float","100|2000|100")
		add_props_to_wdlg(addliststr,props,"other","mask",mask,"string","Yes|No")
		add_props_to_wdlg(addliststr,props,"other","twosided",twosided,"string","Yes|No")
		addliststr.push '</table>'
		jcmd = addliststr.join("\n")
		tbuff.gsub!(/\[BUMP_PROPS\]/,jcmd)

		addliststr = []

		dfcoatprops.each{|coatname,prophash|
			addliststr.push %Q{<table class="mat_table" id="table_coat_#{coatname}">}
			#if coat != "none"
			addliststr.push '<tr><td colspan=2 bgcolor="#555555">' + coatname + 'Properties</td></tr>'
			prophash.keys.sort.each{|dfkey|
				prop = coatprops[dfkey]||prophash[dfkey][1]
				dftype = prophash[dfkey][0]
				dflist = prophash[dfkey][2]
				add_props_to_wdlg(addliststr,coatprops,coatname,dfkey,prop,dftype,dflist)
			}
			addliststr.push '</table>'
			#end
		}
		jcmd = addliststr.join("\n")
		tbuff.gsub!(/\[COAT_PROPS\]/,jcmd)


		addliststr = []

		#if light != "none"
		dflightprops.each{|lightname,prophash|
			addliststr.push %Q{<table class="mat_table" id="table_light_#{lightname}">}
			addliststr.push '<tr><td colspan=2 bgcolor="#555555">' + lightname + 'Properties</td></tr>'
			prophash.keys.sort.each{|dfkey|
				prop = lightprops[dfkey]||prophash[dfkey][1]
				dftype = prophash[dfkey][0]
				dflist = prophash[dfkey][2]
				add_props_to_wdlg(addliststr,lightprops,lightname,dfkey,prop,dftype,dflist)
			}
			addliststr.push '</table>'
		}
		#end
		jcmd = addliststr.join("\n")
		tbuff.gsub!(/\[LIGHT_PROPS\]/,jcmd)

		addliststr = []
		#if dipole != "none"
		dfdipoleprops.each{|dipolename,prophash|
			addliststr.push %Q{<table class="mat_table" id="table_dipole_#{dipolename}">}
			addliststr.push '<tr><td colspan=2 bgcolor="#555555">' + dipolename + 'Properties</td></tr>'
			prophash.keys.sort.each{|dfkey|
				prop = dipoleprops[dfkey]||prophash[dfkey][1]
				dftype = prophash[dfkey][0]
				dflist = prophash[dfkey][2]
				add_props_to_wdlg(addliststr,dipoleprops,dipolename,dfkey,prop,dftype,dflist)
			}
			addliststr.push '</table>'
		}
		#end
		
		jcmd = addliststr.join("\n")
		tbuff.gsub!(/\[SSS_PROPS\]/,jcmd)

		addliststr = []


		save_mat_props( cmat ,props ,coatprops , lightprops , dipoleprops )
		return tbuff,bsdf,coat,light,dipole
	end
	def add_sliders_to_wdlg(addliststr,bsdf,dfkey,prop,dflist,dftype)
		smin = dflist.split("|")[0]
		smax = dflist.split("|")[1]

		sstep = 0.01
		sstep = 1 if dftype == "integer"
		sstep = 100 if dftype == "blackbody"
		sstep = dflist.split("|")[2] if dflist.split("|")[2]

		addliststr.push "$( '#slider_#{bsdf + "_" + dfkey}' ).slider({range: false,min:#{smin},max:#{smax},step:#{sstep},value:#{prop},"
		addliststr.push "slide: function( event, ui ){"
		addliststr.push "$('##{bsdf + "_" + dfkey}').val( ui.value );"
		addliststr.push "saveMaterial();"
		addliststr.push "}});"
	end
	def add_props_to_wdlg(addliststr,props,bsdf,dfkey,prop,dftype,dflist)
		addliststr.push "<tr>"
		if dftype == "float" or dftype == "integer"
			if dfkey == "ImageWidth"
				addliststr.push "<td><p align='right';>#{dfkey} :</p></td>"
				addliststr.push "<td><input type='text' class='textbox' name='#{bsdf + "_" + dfkey}' id='#{bsdf + "_" + dfkey}' value='#{prop}' style='width:75px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle;' onChange='change_width(this);'></td></tr>"
				addliststr.push "<tr><td><p align='right';>ImageHeight :</p></td><td><input type='text' class='textbox' name='Setting_ImageHeight' id='Setting_ImageHeight' value='600' style='width:75px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle;' onChange='change_height(this);'/></td>"
				addliststr.push "</tr><tr><td colspan='2'><div id='slider_#{bsdf + "_" + dfkey}'></div></td>"
				props[dfkey] = prop
			else
				addliststr.push "<td><p align='right';>#{dfkey} :</p></td>"
				addliststr.push "<td><input type='text' class='textbox' name='#{bsdf + "_" + dfkey}' id='#{bsdf + "_" + dfkey}' value='#{prop}' style='width:75px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle;' onChange='change_textbox(this);'/></td>"
				addliststr.push "</tr><tr><td colspan='2'><div id='slider_#{bsdf + "_" + dfkey}'></div></td>"
				props[dfkey] = prop
			end
		elsif dftype == "blackbody"
			addliststr.push "<td><p align='right';>#{dfkey} :</p></td>"
			addliststr.push "<td><input type='text' class='textbox' name='#{bsdf + "_" + dfkey}' id='#{bsdf + "_" + dfkey}' value='#{prop}' style='width:75px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle;' onChange='change_textbox(this);'/>K</td>"
			addliststr.push "</tr><tr><td colspan='2'><div id='slider_#{bsdf + "_" + dfkey}'></div></td>"
			props[dfkey] = prop
		elsif dftype == "srgb" or dftype == "rgb"
			if dflist == "ColorPicker"
				addliststr.push "<td><p align='right';>#{dfkey} :</p></td><td><input id='#{bsdf + "_" + dfkey}' name='#{bsdf + "_" + dfkey}' class='color' value='#{prop}'onchange='updateInfo(this);'/></td>"
				props[dfkey] = prop
			elsif dflist == "Origin"
				addliststr.push "<td><p align='right';>#{dfkey} :</p></td><td><input id='#{bsdf + "_" + dfkey}' name='#{bsdf + "_" + dfkey}' value='From MODEL' disabled='disabled'/></td>"
			end
		elsif dftype == "string" or dftype == "boolean"
			addliststr.push "<td><p align='right';>#{dfkey} :</p></td><td><select name='#{bsdf + "_" + dfkey}' id='#{bsdf + "_" + dfkey}' size='1' style='width:200px' onChange ='saveMaterial()' >"
			dflist.split("|").each{|opt|
				if opt == prop
					addliststr.push "<option selected='selected' value='#{opt}'>#{opt}</option>"
				else
					addliststr.push "<option value='#{opt}'>#{opt}</option>"
				end
			}
			addliststr.push "</select></td>"
			props[dfkey] = prop
		elsif dftype == "file"
			addliststr.push "<td><p align='right';>#{dfkey} :</p></td><td><input type='text' name='#{bsdf + "_" + dfkey}' id='#{bsdf + "_" + dfkey}' value='#{prop}' class='textbox'/>"
			addliststr.push "<input type='button' name='#{bsdf + "_" + dfkey}_select' value='SELECT' onClick='selectfile(\"#{bsdf + "_" + dfkey}\")' class='cssButton'></td>"
			props[dfkey] = prop
		end
		addliststr.push "</tr>"
	end
end
end
end
