module TAK2HATA
module SU2MITSUBA
module SETTINGS
class MITSUBA_CAMERA_FOCUS
	def initialize( wdlg )
		@mitsuba_setting_wdlg = wdlg
		@ip = Sketchup::InputPoint.new
	end

	def activate

		self.reset(nil)
	end

	def deactivate(view)

		view.invalidate
	end

	def onCancel(flag, view)

		Sketchup.active_model.selection.clear
		Sketchup.send_action("selectSelectionTool:")
	end

	def reset(view)
		@ip.clear
		Sketchup.set_status_text( "CLICK TO CAMERA FOCUS.(ESC to EXIT)" )
		@drawn = false
	end
	
	def onLButtonDown(flags, x, y, view)
		@ip.pick( view, x, y )
		camera = view.camera
		fl = camera.eye.distance( @ip.position )
		@mitsuba_setting_wdlg.execute_script("set_text('RenderOption_focusDistance','#{ "%0.3f" % fl.to_m }')" )
		Sketchup.active_model.selection.clear
		Sketchup.send_action("selectSelectionTool:")
	end
end#class MITSUBA_CAMERA_FOCUS
	def render_show_webdialog
		if @mitsuba_setting_wdlg
			@mitsuba_setting_wdlg.bring_to_front
			return
		end

		#htmlcode = create_setting_htmlcode(defaultprops,scprops)
		#filesplit = (__FILE__).split(File::Separator)
		basename = File.basename(__FILE__)
		dirname = File.dirname(__FILE__)
		htmfile = File.join( dirname, "su2objmtl_mitsuba_man1.html" )
		@setting_path = ""
		
		#su2objmtl_mitsuba_man_copy.html
		#jap2englist()
		get_render_path_ini(false)
	    model = Sketchup.active_model
	    @mitsuba_setting_wdlg = UI::WebDialog.new("Mitsuba Render Exporter setting", true, "MitsubaExporterSetting", 355, 465, 150, 150, true)
	    if RUBY_PLATFORM[/darwin/]
			@mitsuba_setting_wdlg.set_file('/'+htmfile)
		else
			@mitsuba_setting_wdlg.set_file(htmfile)
		end
		@mitsuba_setting_wdlg.set_on_close{
			@mitsuba_setting_wdlg = nil
		}
		@mitsuba_setting_wdlg.add_action_callback("focusclick"){|d,p|
			Sketchup.active_model.select_tool( MITSUBA_CAMERA_FOCUS.new(@mitsuba_setting_wdlg) )
		}
	    @mitsuba_setting_wdlg.add_action_callback("loadparam"){|d,p|
			load_parameta()
  	    }
	    @mitsuba_setting_wdlg.add_action_callback("saveparam"){|d,p|
			save_parameta()
  	    }
	    @mitsuba_setting_wdlg.add_action_callback("loadxml"){|d,p|
			read_xmlfile()
  	    }
	    @mitsuba_setting_wdlg.add_action_callback("savexml"){|d,p|
			write_xmlfile()
  	    }
	    @mitsuba_setting_wdlg.add_action_callback("selectfile"){|d,p|
			open_filepath = select_file_dialog(p)
			if open_filepath and open_filepath != ""
				open_filepath.gsub!(/\\/,File::SEPARATOR)
				@mitsuba_setting_wdlg.execute_script( %Q{document.getElementById('#{p}').value='#{open_filepath}';} )
			end
  	    }
	    @mitsuba_setting_wdlg.add_action_callback("selectfile2"){|d,p|
			open_filename = UI.openpanel"Select Mapfile", "", ""
			return if not open_filename
			return if open_filename == ""
			open_filename.gsub!(/\\/,'/')
			cmd="set_text('#{p}','#{open_filename}');"
			@mitsuba_setting_wdlg.execute_script( cmd )
  	    }
	    @mitsuba_setting_wdlg.add_action_callback("selectrender"){|d,p|
			@render_path = @mitsuba_setting_wdlg.get_element_value("render_engin")
			
			if find_render()
				#@render_path.gsub!(/\\/, File::SEPARATOR )
				save_render_path_ini()
				@mitsuba_setting_wdlg.execute_script("document.getElementById('render_engin').value='#{@render_path}';")
			end
			
  	    }

	    @mitsuba_setting_wdlg.add_action_callback("start_objmtl"){|d,p|
			render_props = get_parameta_from_dialog()
			@autorender = "start_render"
			@openimage = "no"
			if render_check()
				startexport(render_props )
			end
	    }
	    @mitsuba_setting_wdlg.show{
			if @render_path and @render_path != ""
				@mitsuba_setting_wdlg.execute_script("document.getElementById('render_engin').value='#{@render_path.gsub(/\\/,'/')}'" ) 
			end
		}

	end
	def select_file_dialog(p)
		path = @mitsuba_setting_wdlg.get_element_value( "#{p}" )
		if path and path != ""
		elsif @render_path and @render_path != ""
			path = File.join(@render_path,"su_render")
		else
			path = ""
		end
		open_filepath = UI.openpanel("Select the file(*|*.*)","","")
		return open_filepath
	end

	def scene_default_props
		scdfprops = {}
		intprops = {}
		scdfprops["Setting"] = {
			"ReadScene"	=>["file","","file"],
			"FPS"	=>["integer",30,"2|30|1"],
			"ExportMode"	=>["string","Refresh_Models","Refresh_Models|Quickly"],
			"ExportView"	=>["string","This_View","This_View|All_Scenes|Animation"],
			"ImageWidth"	=>["integer",800,"320|3200|80"],
			"ImageHeight"	=>["",600,"600|600"],
			"ImageAspect"	=>["string","4:3","16:9|3:2|4:3|1:1|3:4|2:3|9:16"],
			"ImageFormat"	=>["string","EXR","EXR|PNG|JPG"],
			"SaveAlbedo"	=>["string","No","Yes|No"],
			"SaveDistance"	=>["string","No","Yes|No"],
			"UI"			=>["string","GUI","GUI|CommandLine"],
			"Annotation"	=>["string","None","None|Logo|Statics|Logo+Statics"]
		}
		scdfprops["RenderOption"] = {
			"integrator" 	=>["string","volpath","ao|direct|path|volpath_simple|volpath|bdpt|photonmapper|ppm|sppm|pssmlt|mlt|erpt|ptracer|vpl"],
			"type"			=>["string","perspective","thinlens|perspective"],
			"focusDistance"	=>["float",5,"0.0|20"],
			"apertureRadius"=>["float",0.0,"0.0|2.0"],
			"sampleCount"	=>["integer",64,"1|256|1"],
			"rfilter"		=>["string","mitchell","box|tent|gaussian|mitchell|catmullrom|lanczos"],
			"sampler"		=>["string","independent","independent|stratified|ldsampler|halton|hammersley|sobol"],
			"adaptive"		=>["string","off","on|off"],
			"irrcache"		=>["string","off","on|off"]
		}
		scdfprops["Sky"] = {
			"emitter"		=>["string","sky_directional","sun|sunsky|envmap|sky_directional"],
			"envmap"		=>["file","","file"],
			"scale"			=>["float",1,"0|10"],
			"turbidity"		=>["float",3,"1|10"],
			"albedo"		=>["srgb","262626","ColorPicker"],
			"rotation"		=>["integer",0,"0|360"],
			"samplingWeight" =>["float",1,"0|10"]
		}
		intprops["adaptive_setting"] ={
			"maxError" =>["float",0.1,"0.05|1.0|0.05"],
			"maxSampleFactor" =>["integer",13,"1|64|1"],
			"pValue" =>["float",0.05,"0.05|1.0|0.05"]
		}
		intprops["irrcache_setting"] ={
			"resolution" =>["integer",14,"7|49|7"],
			"quality" =>["float",1.0,"0.1|2.0|0.1"],
			"qualityAdjustment" =>["float",1.0,"0.1|1.0|0.1"],
			"gradients" =>["boolean",true],
			"clampNeighbor" =>["boolean",true],
			"clampScreen" =>["boolean",true],
			"overture" =>["boolean",true],
			"indirectOnly" =>["boolean",true]
		}
		intprops["volpath"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"strictNormals"=>["boolean",false],
			"hideEmitters"=>["boolean",false]
		}
		intprops["volpath_simple"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"strictNormals"=>["boolean",false],
			"hideEmitters"=>["boolean",false]
		}
		intprops["path"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"strictNormals"=>["boolean",false],
			"hideEmitters"=>["boolean",false]
		}
		intprops["ao"] = {
			"shadingSamples"=>["integer",1,"1|20|1"],
			"rayLength"=>["float",-1,"500|9999|500"]
		}
		intprops["direct"] = {
			"shadingSamples"=>["integer",16,"8|128|8"],
			"emitterSamples"=>["integer",16,"8|128|8"],
			"bsdfSamples"=>["integer",16,"8|128|8"],
			"strictNormals"=>["boolean",false],
			"hideEmitters"=>["boolean",false]
		}
		intprops["bdpt"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"lightImage"=>["boolean",true],
			"sampleDirect"=>["boolean",true],
			"rrDepth"=>["integer",5,"1|10|1"]
		}
		intprops["photonmapper"] = {
			"directSamples"=>["integer",16,"16|128|16"],
			"glossySamples"=>["integer",32,"16|128|16"],
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"globalPhotons"=>["integer",250000,"50000|1000000|50000"],
			"causticPhotons"=>["integer",250000,"50000|1000000|50000"],
			"volumePhotons"=>["integer",250000,"50000|1000000|50000"],
			"globalLookupRadius"=>["float",0.05,"0.0125|0.5|0.0125"],
			"causticLookupRadius"=>["float",0.0125,"0.0125|0.5|0.0125"],
			"lookupSize"=>["integer",120,"120|1200|120"],
			"granularity"=>["integer",0,"0|10|1"],
			"hideEmitters"=>["boolean",false],
			"rrDepth"=>["integer",5,"1|10|1"]
		}
		intprops["ppm"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"photonCount"=>["integer",250000,"50000|1000000|50000"],
			"initialRadius"=>["float",0.0,"0.0|0.5|0.0125"],
			"alpha"=>["float",0.7,"0.0|1.0|0.1"],
			"granularity"=>["integer",0,"0|10|1"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"maxPasses"=>["integer",-1,"-1|20|1"]
		}
		intprops["sppm"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"photonCount"=>["integer",250000,"50000|1000000|50000"],
			"initialRadius"=>["float",0.0,"0.0|0.5|0.0125"],
			"alpha"=>["float",0.7,"0.0|1.0|0.1"],
			"granularity"=>["integer",0,"0|10|1"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"maxPasses"=>["integer",-1,"-1|20|1"]
		}
		intprops["pssmlt"] = {
			"bidirectional"=>["boolean",true],
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"directSamples"=>["integer",16,"16|128|16"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"luminanceSamples"=>["integer",100000,"10000|1000000|10000"],
			"twoStage"=>["boolean",false],
			"pLargee"=>["float",0.3,"0.0|1.0|0.1"]
		}
		intprops["mlt"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"directSamples"=>["integer",16,"16|128|16"],
			"luminanceSamples"=>["integer",100000,"10000|1000000|10000"],
			"twoStage"=>["boolean",false],
			"lambda"=>["float",50,"10.0|500.0|10.0"]
		}
		intprops["erpt"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"numChains"=>["float",1.0,"0.1|5.0|0.1"],
			"maxChains"=>["float",0.0,"0.0|5.0|0.1"],
			"directSamples"=>["integer",16,"16|128|16"],
			"lambda"=>["float",50,"10.0|500.0|10.0"]
		}
		intprops["ptracer"] = {
			"maxDepth"=>["integer",-1,"-1|20|1"],
			"granularity"=>["integer",0,"0|10|1"],
			"rrDepth"=>["integer",5,"1|10|1"],
			"bruteForce"=>["boolean",false]
		}
		intprops["vpl"] = {
			"maxDepth"=>["integer",5,"-1|20|1"],
			"shadowMapResolution"=>["integer",512,"128|1024|128"],
			"clamping"=>["float",0.1,"0.0|1.0|0.1"]
		}
		intprops["independent"] = {
			"sampleCount"=>["integer",64,"1|16|1"]
		}
		intprops["stratified"] = {
			"sampleCount"=>["integer",64,"1|16|1"],
			"dimension"=>["integer",4,"1|16|1"]
		}
		intprops["ldsampler"] = {
			"sampleCount"=>["integer",64,"1|16|1"],
			"dimension"=>["integer",4,"1|16|1"]
		}
		intprops["halton"] = {
			"sampleCount"=>["integer",64,"1|16|1"],
			"scramble"=>["integer",1,"-1|10|1"]
		}
		intprops["hammersley"] = {
			"sampleCount"=>["integer",64,"1|16|1"],
			"scramble"=>["integer",1,"-1|10|1"]
		}
		intprops["sobol"] = {
			"sampleCount"=>["integer",64,"1|16|1"],
			"scramble"=>["integer",1,"-1|10|1"]
		}
		intprops["ldr"] = {
			"exposure"=>["float",0,"-10|10|0.01"],
			"gamma"=>["float",-1,"-1|2.2|0.1"]
		}
		return scdfprops,intprops
	end
	def get_scene_props_from( obj = Sketchup.active_model )
		if not obj.attribute_dictionaries["T2H_MITSUBA_SETTING"]
			return nil
		end
		dfprops , dfintprops= scene_default_props
		scprops = {}
		intprops = {}
		adptprops = {}
		irrprops = {}
		smplprops = {}
		ldrprops = {}
		dfprops.each{|scenekey,prophash|
			props = {}
			prophash.each{|propkey,proparray|
				dftype = proparray[0]
				pval = obj.get_attribute("T2H_MITSUBA_SETTING","#{scenekey}_#{propkey}",proparray[1])
				props[propkey] = [ pval , dftype ]
			}
			scprops[scenekey] = props
		}
		dfintprops2 = dfintprops[scprops["RenderOption"]["integrator"][0]]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = obj.get_attribute("T2H_MITSUBA_SETTING","IntegratorOption_#{propkey}",proparray[1])
				intprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops["adaptive_setting"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = obj.get_attribute("T2H_MITSUBA_SETTING","adaptive_setting_#{propkey}",proparray[1])
				adptprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops["irrcache_setting"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = obj.get_attribute("T2H_MITSUBA_SETTING","irrcache_setting_#{propkey}",proparray[1])
				irrprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops[scprops["RenderOption"]["sampler"][0]]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = obj.get_attribute("T2H_MITSUBA_SETTING","RenderOption_#{propkey}",proparray[1])
				smplprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops["ldr"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = obj.get_attribute("T2H_MITSUBA_SETTING","ldr_option_#{propkey}",proparray[1])
				ldrprops[propkey] = [ pval , dftype ]
			}
		end
		render_props = {}
		render_props["scene"] = scprops
		render_props["integrator"] = intprops
		render_props["adaptive"] = adptprops
		render_props["irrcache"] = irrprops
		render_props["sampler"] = smplprops
		render_props["ldr"] = ldrprops
		return render_props
	end
	def get_parameta_from_dialog()
		defaultprops , dfintprops= scene_default_props
		scprops = {}
		intprops= {}
		adptprops = {}
		irrprops = {}
		smplprops = {}
		ldrprops = {}
		@render_setting_file = File.basename(__FILE__)

		defaultprops.each{|scenekey,prophash|
			props = {}
			prophash.each{|propkey,proparray|
				dftype = proparray[0]
				dflist = proparray[2]
				pval = @mitsuba_setting_wdlg.get_element_value( scenekey + "_" + propkey )||proparray[1].to_s
				props[propkey] = [pval , dftype]
			}
			scprops[scenekey] = props
		}
		@twosided = "Yes"##@mitsuba_setting_wdlg.get_element_value( "Setting_Twosided" )
		#integratorのオプションを取得する
		dfintprops2 = dfintprops[scprops["RenderOption"]["integrator"][0]]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = @mitsuba_setting_wdlg.get_element_value( "IntegratorOption_#{propkey}" )||proparray[1].to_s
				intprops[propkey] = [pval , dftype]
			}
		end
		dfintprops2 = dfintprops["adaptive_setting"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = @mitsuba_setting_wdlg.get_element_value( "adaptive_setting_#{propkey}" )||proparray[1].to_s
				adptprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops["irrcache_setting"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = @mitsuba_setting_wdlg.get_element_value( "irrcache_setting_#{propkey}" )||proparray[1].to_s
				irrprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops[scprops["RenderOption"]["sampler"][0]]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = @mitsuba_setting_wdlg.get_element_value( "samplerOption_#{propkey}" )||proparray[1].to_s
				smplprops[propkey] = [ pval , dftype ]
			}
		end
		dfintprops2 = dfintprops["ldr"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				pval = @mitsuba_setting_wdlg.get_element_value( "ldr_option_#{propkey}" )||proparray[1].to_s
				ldrprops[propkey] = [ pval , dftype ]
			}
		end
		@defcolor =  @mitsuba_setting_wdlg.get_element_value( "Setting_DefaultColor" )
		render_props = {}
		render_props["scene"] = scprops
		render_props["integrator"] = intprops
		render_props["adaptive"] = adptprops
		render_props["irrcache"] = irrprops
		render_props["sampler"] = smplprops
		render_props["ldr"] = ldrprops
		return render_props
	end
	def save_parameta(obj=Sketchup.active_model)
		render_props = get_parameta_from_dialog()
		scprops = render_props["scene"]
		intprops = render_props["integrator"]
		adptprops = render_props["adaptive"]
		irrprops = render_props["irrcache"]
		smplprops = render_props["sampler"]
		ldrprops = render_props["ldr"]
		Sketchup.active_model.start_operation("Mitsuba Scene Setting Save")
		scprops.each{|scenekey,prophash|
			prophash.each{|propkey,val|
				obj.set_attribute("T2H_MITSUBA_SETTING","#{scenekey}_#{propkey}",val[0])
			}
		}
		intprops.each{|propkey,val|
			obj.set_attribute("T2H_MITSUBA_SETTING","IntegratorOption_#{propkey}",val[0])
		}
		adptprops.each{|propkey,val|
			obj.set_attribute("T2H_MITSUBA_SETTING","adaptive_setting_#{propkey}",val[0])
		}
		irrprops.each{|propkey,val|
			obj.set_attribute("T2H_MITSUBA_SETTING","irrcache_setting_#{propkey}",val[0])
		}
		smplprops.each{|propkey,val|
			obj.set_attribute("T2H_MITSUBA_SETTING","RenderOption_#{propkey}",val[0])
		}
		ldrprops.each{|propkey,val|
			obj.set_attribute("T2H_MITSUBA_SETTING","ldr_option_#{propkey}",val[0])
		}
		Sketchup.active_model.commit_operation
	end
	def write_xmlfile()
		settingfile = UI.savepanel("Select XML file(xml|*.xml)","","*.xml")
		if settingfile and settingfile != ""
			if File.extname(settingfile).upcase != ".XML"
				settingfile = settingfile + ".xml"
			end
			of = File.new(settingfile, "w")
			of.close
			if File.exists?(settingfile)
				@render_setting_code = {}
				@t2h_stored_lights = []
				render_props = get_parameta_from_dialog()
				export_render_scene(render_props,settingfile)
			else
				UI.messagebox("Can not write XML to that file path")
			end
		end
	end
	def read_xmlfile()
		settingfile = UI.openpanel("Select XML file(xml|*.xml)","","*.xml")
		if settingfile and settingfile != "" 
			if File.exists?(settingfile)
				#アニメーション用のレンダリング設定を保存されたシーンから取り込む
				buff_hash = {}
				scf = File.new(settingfile, "r")
				scfbuff = scf.read
				scf.close
				dfprops , dfintprops= scene_default_props
				scprops = {}
				intprops = {}
				adptprops = {}
				irrprops = {}
				smplprops = {}
				ldrprops = {}
				scprops["RenderOption"] = {}
				scprops["Sky"] = {}
				scprops["Setting"] = {}
				scprops["RenderOption"]["adaptive"] = ["off","string"]
				scprops["RenderOption"]["irrcache"] = ["off","string"]
				if /<integrator type=\"adaptive\"/ =~ scfbuff
					scprops["RenderOption"]["adaptive"] = ["on","string"]
				end
				if /<integrator type=\"irrcache\"/ =~ scfbuff
					scprops["RenderOption"]["irrcache"] = ["on","string"]
				end
				integrator = ""
				scfbuff.scan(/<integrator type=\"(.*)\"/) {|word|
					scprops["RenderOption"]["integrator"] = [word[0],"string"] 
					integrator = word[0]
				}
				if /<sensor type=\"(.*)\"/ =~ scfbuff
					scprops["RenderOption"]["type"] = [$1,"string"]
				end
				sampler=""
				if /<sampler type=\"(.*)\"/ =~ scfbuff
					scprops["RenderOption"]["sampler"] = [$1,"string"]
					sampler=$1
				end
				if /<film type=\"hdrfilm\"/ =~ scfbuff
					scprops["Setting"]["ImageFormat"] = ["EXR","string"]
				else
					scprops["Setting"]["ImageFormat"] = ["PNG","string"]
				end
				if /<integer name=\"width\" value=\"(\d*)\"/ =~ scfbuff
					scprops["Setting"]["ImageWidth"] = [$1,"integer"]
				end
				if /<integer name=\"height\" value=\"(\d*)\"/ =~ scfbuff
					scprops["Setting"]["ImageHeight"] = [$1,"integer"]
				end
				if scprops["Setting"]["ImageWidth"] and scprops["Setting"]["ImageHeight"]
					aspect = scprops["Setting"]["ImageWidth"][0].to_f / scprops["Setting"]["ImageHeight"][0].to_f
					if ( aspect - ( 4.0 / 1.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "4:1" , "string"]
					elsif ( aspect - ( 3.0 / 1.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "3:1" , "string"]
					elsif ( aspect - ( 2.0 / 1.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "2:1" , "string"]
					elsif ( aspect - ( 16.0 / 9.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "16:9" , "string"]
					elsif ( aspect - ( 3.0 / 2.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "3:2" , "string"]
					elsif ( aspect - ( 4.0 / 3.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "4:3" , "string"]
					elsif ( aspect - ( 1.0 / 1.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "1:1" , "string"]
					elsif ( aspect - ( 3.0 / 4.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "3:4" , "string"]
					elsif ( aspect - ( 2.0 / 3.0 ) ) > -0.1
						scprops["Setting"]["ImageAspect"] = [ "2:3" , "string"]
					else
						scprops["Setting"]["ImageAspect"] = [ "9:16" , "string"]
					end
				end
				

				dfprops.each{|optkey,optionhash|
					optionhash.each{|propkey,proparray|
						if /<#{proparray[0]} name=\"#{propkey}\" value=\"(.*)\"/ =~ scfbuff
							scprops[optkey][propkey] = [$1,proparray[0]]
						end
					}
				}
				dfintprops2 = dfintprops[integrator]
				if dfintprops2
					dfintprops2.each{|propkey,proparray|
						if /<#{proparray[0]} name=\"#{propkey}\" value=\"(.*)\"/ =~ scfbuff
							intprops[propkey] = [$1,proparray[0]]
						else
						end	
					}
				end
				dfintprops2 = dfintprops["adaptive_setting"]
				if dfintprops2
					dfintprops2.each{|propkey,proparray|
						if /<#{proparray[0]} name=\"#{propkey}\" value=\"(.*)\"/ =~ scfbuff
							adptprops[propkey] = [$1,proparray[0]]
						end
					}
				end
				dfintprops2 = dfintprops["irrcache_setting"]
				if dfintprops2
					dfintprops2.each{|propkey,proparray|
						if /<#{proparray[0]} name=\"#{propkey}\" value=\"(.*)\"/ =~ scfbuff
							irrprops[propkey] = [$1,proparray[0]]
						end
					}
				end

				dfintprops2 = dfintprops[sampler]
				if dfintprops2
					dfintprops2.each{|propkey,proparray|
						if /<#{proparray[0]} name=\"#{propkey}\" value=\"(.*)\"/ =~ scfbuff
							smplprops[propkey] = [$1,proparray[0]]
						end
					}
				end
				dfintprops2 = dfintprops["ldr"]
				if dfintprops2
					dfintprops2.each{|propkey,proparray|
						if /<#{proparray[0]} name=\"#{propkey}\" value=\"(.*)\"/ =~ scfbuff
							ldrprops[propkey] = [$1,proparray[0]]
						end
					}
				end
				
				render_props = {}
				render_props["scene"] = scprops
				render_props["integrator"] = intprops
				render_props["adaptive"] = adptprops
				render_props["irrcache"] = irrprops
				render_props["sampler"] = smplprops
				render_props["ldr"] = ldrprops
				load_parameta_prop(render_props)
			else
				UI.messagebox "can not read file"
			end
		end
	end
	def load_parameta(obj=Sketchup.active_model)
		render_props = get_scene_props_from(obj)
		if render_props
			load_parameta_prop(render_props)
		else
			UI.messagebox("setting not exist")
		end
	end
	def load_parameta_prop(render_props)
		defaultprops , dfintprops= scene_default_props
		
		scprops = render_props["scene"]
		intprops = render_props["integrator"]
		adptprops = render_props["adaptive"]
		irrprops = render_props["irrcache"]
		smplprops = render_props["sampler"]
		ldrprops = render_props["ldr"]
		
		defaultprops.each{|scenekey,prphash|
			prphash.each{|propkey,proparray|
				dftype = proparray[0]
				if scprops[scenekey][propkey]
					prop = scprops[scenekey][propkey][0]||proparray[1]
					set_wdlg_value(scenekey,propkey,dftype,prop)
				end
			}
		}
		#integratorのオプションを取得する
		if scprops["RenderOption"]["integrator"]
			dfintprops2 = dfintprops[scprops["RenderOption"]["integrator"][0]]
		end
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				if intprops[propkey]
					prop = intprops[propkey][0]||proparray[1]
					set_wdlg_value("IntegratorOption",propkey,dftype,prop)
				end
			}
		end
		dfintprops2 = dfintprops["adaptive_setting"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				if adptprops[propkey]
					prop = adptprops[propkey][0]||proparray[1]
					set_wdlg_value("adaptive_setting",propkey,dftype,prop)
				end
			}
		end
		dfintprops2 = dfintprops["irrcache_setting"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				if irrprops[propkey]
					prop = irrprops[propkey][0]||proparray[1]
					set_wdlg_value("irrcache_setting",propkey,dftype,prop)
				end
			}
		end
		if scprops["RenderOption"]["sampler"]
			dfintprops2 = dfintprops[scprops["RenderOption"]["sampler"][0]]
		end
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				if smplprops[propkey]
					prop = smplprops[propkey][0]||proparray[1]
					@mitsuba_setting_wdlg.execute_script("selectListbox('samplerOption_#{propkey}','#{prop.to_s}')" )
				end
			}
		end
		dfintprops2 = dfintprops["ldr"]
		if dfintprops2
			dfintprops2.each{|propkey,proparray|
				dftype = proparray[0]
				if ldrprops[propkey]
					prop = ldrprops[propkey][0]||proparray[1]
					set_wdlg_value("ldr_option",propkey,dftype,prop)
				end
			}
		end
		@mitsuba_setting_wdlg.execute_script("all_option_update();")
	end
	def set_wdlg_value(scenekey,propkey,dftype,prop)
		if dftype == "string" or dftype == "boolean" or  ["sampleCount" ,"dimension","scramble"].include?(propkey)
			@mitsuba_setting_wdlg.execute_script("selectListbox('#{scenekey}_#{propkey}','#{prop.to_s}')" )
		elsif dftype == "rgb" or  dftype == "srgb"
			if prop and prop != "" and prop[0,1] == "#"
				prop.delete!("#")
			end
			@mitsuba_setting_wdlg.execute_script("set_text('#{scenekey}_#{propkey}','#{prop.to_s.gsub(/\\/,'/')}')" )
			@mitsuba_setting_wdlg.execute_script("set_color('#{scenekey}_#{propkey}','##{prop.to_s.gsub(/\\/,'/')}')" )
		else
			@mitsuba_setting_wdlg.execute_script("set_text('#{scenekey}_#{propkey}','#{prop.to_s.gsub(/\\/,'/')}')" )
			if propkey == "envmap"
				if prop and prop != "" and prop[0,1] == "#"
					prop.delete!("#")
				end
				@mitsuba_setting_wdlg.execute_script("set_color('#{scenekey}_#{propkey}','##{prop.to_s.gsub(/\\/,'/')}')" )
			end
		end
	end
end
end
end
